/*
 * Copyright 2014 Netflix, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.netflix.eureka2.metric;

import com.netflix.eureka2.channel.InterestChannel;
import com.netflix.spectator.api.ExtendedRegistry;

/**
 * @author Tomasz Bak
 */
public class SpectatorInterestChannelMetrics extends AbstractStateMachineMetrics<InterestChannel.STATE> implements InterestChannelMetrics {
    public SpectatorInterestChannelMetrics(ExtendedRegistry registry, String name) {
        super(registry, name, InterestChannel.STATE.class);
    }
}
